//
//  ViewController.swift
//  MazeBoard
//
//  Created by narita on 2017/07/10.
//  Copyright © 2017年 narita. All rights reserved.
//

import Cocoa

class ViewController: NSViewController {

    override func viewDidLoad()
    {
        super.viewDidLoad()

        // Do any additional setup after loading the view.

        self.imageView.scaleUnitSquare(to: NSMakeSize(8, 8))

        self.maze = MazeBoard(width:50, height:50)

        // メインスレッドで
        slider.isEnabled = false

        // イベントループを回してnibの構築をさせた後に迷路の作成に入る。
        // 以下のコメントを外すと、すぐに迷路の作成開始。performSelectorは使用できない....
//        OperationQueue.main.addOperation 
//        {
//            self.makeMaze()
//        }
    }

    // firtResponder経由でコマンドNと結びつけてます。
    @IBAction func makeMaze( sender : NSMenu!)
    {
        slider.minValue = 0
        slider.maxValue = 0
        slider.integerValue = 0

        // サブスレッドで実行する
        OperationQueue().addOperation
        {
            self.maze.doDig(MazePos(1,1))
            {                
                self.mazeArray.append($0.DebugImage())

                OperationQueue.main.addOperation 
                {
                        // UIの更新はメインスレッドで実行される事
                        self.slider.minValue = 0
                        self.slider.maxValue = Double(self.mazeArray.count) - 1.0
                        self.slider.integerValue = Int(self.slider.maxValue)
                        
                        self.imageView.image = self.mazeArray[self.slider.integerValue ]  
                }
            }
            
            OperationQueue.main.addOperation 
            {
                    // 完了処理もメインスレッドで
                self.slider.isEnabled = true
                
                NSBeep()
            }
        }        
    }
    
    @IBAction func imageChange( sender : NSSlider!)
    {
        self.imageView.image = self.mazeArray[sender.integerValue ]
    }

    override var representedObject: Any? 
    {
        didSet 
        {
            // Update the view, if already loaded.
        }
    }

    @IBOutlet weak var slider: NSSlider!
    @IBOutlet weak var imageView: NSImageView!
    
    var mazeArray : Array<NSImage> = []
    var maze : MazeBoard! = nil
}

